var Thead = "\
<thead>\
<tr><th>s</th><th>m</th></tr>\
</thead>";

var Max_speed_a_length = 10;     // őfXg

var g = new Object;
g.attempt_number = null;        // s
g.speed_a = null;               // f
g.label_a = null;               // x
g.perm2count_a = null;          // toJEg
g.perm2permlabel_a = null;      // to񃉃x

var _ = document.getElementById;
function value_of_select (id)
{
  return _(id).options[_(id).options.selectedIndex].value;
}

//+ Jonas Raoni Soares Silva
//@ http://jsfromhell.com/array/permute [rev. #1]

permute = function(v, m){
	for(var p = -1, j, k, f, r, l = v.length, q = 1, i = l + 1; --i; q *= i);
	for(x = [new Array(l), new Array(l), new Array(l), new Array(l)], j = q, k = l + 1, i = -1;
		++i < l; x[2][i] = i, x[1][i] = x[0][i] = j /= --k);
	for(r = new Array(q); ++p < q;)
		for(r[p] = new Array(l), i = -1; ++i < l; !--x[1][i] && (x[1][i] = x[0][i],
			x[2][i] = (x[2][i] + 1) % l), r[p][i] = m ? x[3][i] : v[x[3][i]])
			for(x[3][i] = x[2][i], f = 0; !f; f = !f)
				for(j = i; j; x[3][--j] == x[2][i] && (x[3][i] = x[2][i] = (x[2][i] + 1) % l, f = 1));
	return r;
};

function parse (s)
{
  g.speed_a = new Array;
  g.label_a = new Array;

  var count = 0;
  var re = new RegExp ("(?:([^\\s@:]+):)?(\\d+)[\\s@]*", "ig");
  var callback =
    function (all, label, speed)
    {
      if (count >= Max_speed_a_length
          ||  count > 10)        // 10܂ł퓮삵Ȃ
        return;

      g.speed_a.push (speed);
      g.label_a.push (label ? label : speed);
      ++count;
    }

  s.replace (re, callback);
}

// _ȉ1ʂ܂Ł`
function count2probstr (n)
{
  var r =  n / g.attempt_number * 100;
  r = new String (Math.round (r * 10) / 10); // _ȉ2ʂľܓ
  if (n != 0 && r.indexOf (".") < 0)
    r += ".0";                   // ".0"t
  return r + "%";
}

function change_result ()
{
  var tmp_a = new Array;

  // \[gł`ɂ
  for (var perm in g.perm2count_a)
    {
      var obj = new Object;
      obj.perm = perm;
      obj.count = g.perm2count_a[perm];
      tmp_a.push (obj);
    }

  // mŃ\[g
  if (_("sort-by-prob").checked)
    tmp_a.sort (function (a, b) { return b.count - a.count; });

  var r = "";

  for (var i in tmp_a)
    {
      r += "<tr>";
      r += "<th>" + g.perm2permlabel_a[tmp_a[i].perm]  + "</th>";
      r += "<td>" + count2probstr (tmp_a[i].count) + "</td>";
      r += "</tr>\n";
    }

  _("result").innerHTML =
    ("<table>"
     + Thead
     + "<tbody>" + r + "</tbody>"
     + "</table>");
}

// f->_֐Ԃ
function make_speed2score (numbering)
{
  switch (numbering)
    {
      // [SFC12͓GƖŎ_̎Ⴄ̂B߂ǂ[
      // Krỉ:http://kri.client.jp/RTA/DQ1-2_other.html

    case "SFC:3":
      // ͎(http://www.geocities.jp/hikari_no_yoroi/dq3_spd255.html)ƍ񂩂
      // http://d.hatena.ne.jp/dq_492/20100929/1281515781
      // return (speed + 20) * Math.floor (Math.random () * 256) >> 8;

      // p_̉:http://harapan.exblog.jp/13896303/
      return function (speed) { return Math.pow(speed, 2) * Math.random (); }

    case "SFC:5":
      // Krỉ:http://kri.client.jp/RTA/DQ5_speed.html#1
      return function (speed) { return speed * (75 + Math.random () * 25); }

    case "PS:7":
    case "PS2:5":
    case "PS2:8":
      // Ẳ
      return function (speed) { return speed * (50 + Math.random () * 50); }

    default:
      alert ("svZ킩܂[");
      return function (speed) { return -1; }
    }
}

function calc1 ()
{
  var speed2score = make_speed2score (value_of_select ("numbering"));

  for (var i = 0; i < g.attempt_number; ++i)
    {
      var r = new Array;
      for (var ii = 0; ii < g.speed_a.length; ++ii)
        {
          // .place:̈ʒuA.score:_
          r[ii] = new Object;
          r[ii].place = ii;
          r[ii].score = speed2score (g.speed_a[ii]);
        }
      // _Ń\[g
      r.sort (function (a, b) { return b.score - a.score; });

      var perm = "";
      for (var ii = 0; ii < r.length; ++ii)
        perm += r[ii].place;
      ++g.perm2count_a[perm];
    }
}

function calc ()
{
  // s
  g.attempt_number = parseInt(_("input-attempt-number").value);

  g.perm2count_a = new Array;
  g.perm2permlabel_a = new Array;

  // fXg
  parse (_("input-speed-list").value);

  var index_a = new Array;
  for (var i in g.label_a)
    index_a[i] = new String (i);

  var perm_a = permute (index_a); // CfbNX
  var permlabel_a = permute (g.label_a); // 񃉃x

  for (var i in perm_a)
    {
      // [0,1,2,3] -> "0123" ꂪ񃉃xƃJEgɋʂL[
      var perm = perm_a[i].join("");

      g.perm2count_a[perm] = 0;
      g.perm2permlabel_a[perm] = permlabel_a[i].join("  ")
    }

  calc1 ();

  change_result ();
}

function init ()
{
  document.title = hta.applicationname + ' v' + hta.version;

  window.resizeTo(320, 320);

  calc ();
}
